#pragma once
#include <vulkan/vulkan.hpp>

#include "rhi/texture.h"


class texture_vk : public texture {
public:
    bool init_data(const unsigned char* data, int width, int height) override;
    bool is_valid() const override { return image_view_; }
    ImTextureID get_texture_id() override { return static_cast<VkImageView>(image_view_); }
private:
    vk::Image image_;
    vk::ImageView image_view_;
    vk::Sampler sampler_;
    vk::Buffer buffer_;
};
